// =====================================================================
// SuperCollider Workspace
// =====================================================================

-+- livecoding
-+- writing classes
-+- patterns

--- granular spatialisation
UGens:
GrainSin, GrainBuf, GrainFM, GrainIn
-> pan position argument

Creating short synths, and using patterns to instantiate them.
Interesting helpfile: [recursive_phrasing]

--- hid on linux
GeneralHID - cross platform abstraction
LID - linux input device layer
[Linux_udev_setup] - helpfile on ensuring right permissions on linux input devices

--- osc - communication with other programs

Shortcuts

Basic:
OSC_communication

Useful extensions:
Quarks -
OpenObject
SenseWorld DataNetwork


--- ats
Ats synths in SC3-plugins


// Extensions for SuperCollider
Quarks.gui;

http://quarks.sourceforge.net
http://sc3-plugins.sourceforge.net


/// TOMORROW - Livecoding jam in the Sound Night concert
// --- http://github.com/sensestage/olympic




www.beast.bham.ac.uk/research/mulch.shtml
www.dxarts.washington.edu/ats






// ----------------- Pattern ----------


Help.gui;

e.inspect


e.play;

s.makeGui;

s.queryAllNodes( true )


Platform.userAppSupportDir;


(
SynthDef( \myownsynth, { arg out=0,pan=0,freq=440,amp=0.1,gate=1,dur=1,dustrate=100, rq=0.1;
	Out.ar( out,
		Pan2.ar(
			EnvGen.kr( Env.adsr, gate, timeScale: dur, doneAction: 2 ) *
			BPF.ar( Dust.ar(dustrate), freq, rq ) * 40 * amp
			, pan )
	);
}).store
);

(instrument: \myownsynth, amp: 1, rq: 0.05, freq: 2000 ).play;

(instrument: \myownsynth, amp: 1, rq: 0.05, degree: 2, octave: 8, dur: 10 ).play;

(
p = Pbind( 
	\instrument, \myownsynth,
	\degree, Pn( Pshuf( (0..6), 4), inf ),
	\octave, Pstutter( 7, Pseq( [8,9,10], inf ) ),
	\dur, 0.1,
	\rq, 0.05,
	\amp, 1
).play;
)

p.play;

p.stop;


s.scope;